'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ANIMATION_DURATION = 500;

var ReactDribbleButton = function (_PureComponent) {
  (0, _inherits3.default)(ReactDribbleButton, _PureComponent);

  function ReactDribbleButton() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ReactDribbleButton);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ReactDribbleButton.__proto__ || (0, _getPrototypeOf2.default)(ReactDribbleButton)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      effects: []
    }, _this.onClick = function (event) {
      _this.updateEffects(event);

      if (_this.props.onClick) {
        _this.props.onClick(event);
      }
    }, _this.renderEffects = function (effectClassName) {
      if (!_this.button) {
        return null;
      }

      var _this$button$getBound = _this.button.getBoundingClientRect(),
          left = _this$button$getBound.left,
          top = _this$button$getBound.top;

      var diameter = Math.max(_this.button.offsetWidth, _this.button.offsetHeight);

      return _this.state.effects.map(function (_ref2) {
        var date = _ref2.date,
            pageX = _ref2.pageX,
            pageY = _ref2.pageY;

        var effectStyle = {
          top: pageY - (top + window.pageYOffset) + 'px',
          left: pageX - (left + window.pageXOffset) + 'px',
          width: diameter + 'px',
          height: diameter + 'px'
        };

        return _react2.default.createElement('i', {
          key: date,
          style: effectStyle,
          className: 'react-dribble-button__effect ' + effectClassName
        });
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ReactDribbleButton, [{
    key: 'updateEffects',
    value: function updateEffects(_ref3) {
      var pageX = _ref3.pageX,
          pageY = _ref3.pageY;

      var now = Date.now();

      this.setState(function (_ref4) {
        var effects = _ref4.effects;
        return {
          effects: [].concat((0, _toConsumableArray3.default)(effects.filter(function (_ref5) {
            var date = _ref5.date;
            return now - date < ANIMATION_DURATION;
          })), [{
            date: Date.now(),
            pageX: pageX,
            pageY: pageY
          }])
        };
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          color = _props.color,
          children = _props.children,
          component = _props.component,
          className = _props.className,
          effectClassName = _props.effectClassName,
          props = (0, _objectWithoutProperties3.default)(_props, ['color', 'children', 'component', 'className', 'effectClassName']);


      var Component = component;

      return _react2.default.createElement(
        Component,
        (0, _extends3.default)({}, props, {
          ref: function ref(_ref6) {
            _this2.button = _ref6;
          },
          onClick: this.onClick,
          className: 'react-dribble-button --' + color + ' ' + className
        }),
        this.renderEffects(effectClassName),
        children
      );
    }
  }]);
  return ReactDribbleButton;
}(_react.PureComponent);

ReactDribbleButton.propTypes = {
  color: _propTypes2.default.oneOf(['red', 'pink', 'blue', 'cyan', 'teal', 'lime', 'grey', 'green', 'amber', 'brown', 'black', 'orange', 'purple', 'yellow', 'indigo', 'default', 'blue-grey', 'light-blue', 'light-green', 'deep-orange', 'deep-purple']),
  onClick: _propTypes2.default.func,
  children: _propTypes2.default.children,
  className: _propTypes2.default.string,
  component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  effectClassName: _propTypes2.default.string
};
ReactDribbleButton.defaultProps = {
  onClick: null,
  children: null,
  className: '',
  component: 'button',
  color: 'default',
  effectClassName: ''
};
exports.default = ReactDribbleButton;
